wxTarInputStream Class Reference | wxWidgets

| Version: 3.2.11

Loading...
Searching...
No Matches
Public Member Functions | List of all members
wxTarInputStream Class Reference
Class List by Category » Archive support | Class List by Category » Streams

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.2/wxWidgets3.2-3.2.11-1.x86_64/src/wxWidgets-3.2.11/interface/wx/tarstrm.h>`

Inheritance diagram for wxTarInputStream:
[legend]

## Detailed Description

Input stream for reading tar files.

wxTarInputStream::GetNextEntry() returns a wxTarEntry object containing the meta-data for the next entry in the tar (and gives away ownership). Reading from the wxTarInputStream then returns the entry's data. wxTarInputStream::Eof() becomes true after an attempt has been made to read past the end of the entry's data.

When there are no more entries, wxTarInputStream::GetNextEntry() returns NULL and sets wxTarInputStream::Eof().

Tar entries are seekable if the parent stream is seekable. In practice this usually means they are only seekable if the tar is stored as a local file and is not compressed.

##

Library: wxBase
Category: Archive support, Streams

See also
  Looking Up an Archive Entry by Name

## Public Member Functions
bool | CloseEntry ()
| Closes the current entry.
wxTarEntry * | GetNextEntry ()
| Closes the current entry if one is open, then reads the meta-data for the next entry and returns it in a wxTarEntry object, giving away ownership.
bool | OpenEntry (wxTarEntry &entry)
| Closes the current entry if one is open, then opens the entry specified by the entry object.
| wxTarInputStream (wxInputStream &stream, wxMBConv &conv=wxConvLocal)
| Constructor.
| wxTarInputStream (wxInputStream *stream, wxMBConv &conv=wxConvLocal)
| Constructor.
Public Member Functions inherited from wxArchiveInputStream
wxArchiveEntry * | GetNextEntry ()
| Closes the current entry if one is open, then reads the meta-data for the next entry and returns it in a wxArchiveEntry object, giving away ownership.
virtual bool | OpenEntry (wxArchiveEntry &entry)=0
| Closes the current entry if one is open, then opens the entry specified by the wxArchiveEntry object.
Public Member Functions inherited from wxFilterInputStream
| wxFilterInputStream (wxInputStream &stream)
| Initializes a "filter" stream.
| wxFilterInputStream (wxInputStream *stream)
| Initializes a "filter" stream.
Public Member Functions inherited from wxInputStream
| wxInputStream ()
| Creates a dummy input stream.
virtual | ~wxInputStream ()
| Destructor.
virtual bool | CanRead () const
| Returns true if some data is available in the stream right now, so that calling Read() wouldn't block.
virtual bool | Eof () const
| Returns true after an attempt has been made to read past the end of the stream.
int | GetC ()
| Returns the first character in the input queue and removes it, blocking until it appears if necessary.
virtual size_t | LastRead () const
| Returns the last number of bytes read.
virtual char | Peek ()
| Returns the first character in the input queue without removing it.
virtual wxInputStream & | Read (void *buffer, size_t size)
| Reads the specified amount of bytes and stores the data in buffer.
wxInputStream & | Read (wxOutputStream &stream_out)
| Reads data from the input queue and stores it in the specified output stream.
bool | ReadAll (void *buffer, size_t size)
| Reads exactly the specified number of bytes into the buffer.
virtual wxFileOffset | SeekI (wxFileOffset pos, wxSeekMode mode=wxFromStart)
| Changes the stream current position.
virtual wxFileOffset | TellI () const
| Returns the current stream position or wxInvalidOffset if it's not available (e.g.
size_t | Ungetch (const void *buffer, size_t size)
| This function is only useful in read mode.
bool | Ungetch (char c)
| This function acts like the previous one except that it takes only one character: it is sometimes shorter to use than the generic function.
Public Member Functions inherited from wxStreamBase
| wxStreamBase ()
| Creates a dummy stream object.
virtual | ~wxStreamBase ()
| Destructor.
wxStreamError | GetLastError () const
| This function returns the last error.
virtual wxFileOffset | GetLength () const
| Returns the length of the stream in bytes.
virtual size_t | GetSize () const
| This function returns the size of the stream.
virtual bool | IsOk () const
| Returns true if no error occurred on the stream.
virtual bool | IsSeekable () const
| Returns true if the stream supports seeking to arbitrary offsets.
void | Reset (wxStreamError error=wxSTREAM_NO_ERROR)
| Resets the stream state.
bool | operator! () const
| Returns the opposite of IsOk().

## Additional Inherited Members
Protected Member Functions inherited from wxInputStream
size_t | OnSysRead (void *buffer, size_t bufsize)=0
| Internal function.
Protected Member Functions inherited from wxStreamBase
virtual wxFileOffset | OnSysSeek (wxFileOffset pos, wxSeekMode mode)
| Internal function.
virtual wxFileOffset | OnSysTell () const
| Internal function.

## Constructor & Destructor Documentation

## ◆ wxTarInputStream() [1/2]

wxTarInputStream::wxTarInputStream | ( | wxInputStream & | stream,
|  | wxMBConv & | conv = wxConvLocal )

Constructor.

In a Unicode build the second parameter conv is used to translate fields from the standard tar header into Unicode.

It has no effect on the stream's data. conv is only used for the standard tar headers, any pax extended headers are always UTF-8 encoded.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

## ◆ wxTarInputStream() [2/2]

wxTarInputStream::wxTarInputStream | ( | wxInputStream * | stream,
|  | wxMBConv & | conv = wxConvLocal )

Constructor.

In a Unicode build the second parameter conv is used to translate fields from the standard tar header into Unicode.

It has no effect on the stream's data. conv is only used for the standard tar headers, any pax extended headers are always UTF-8 encoded.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

## Member Function Documentation

## ◆ CloseEntry()

bool wxTarInputStream::CloseEntry | ( |  | ) |
| virtual

Closes the current entry.

On a non-seekable stream reads to the end of the current entry first.

Implements wxArchiveInputStream.

## ◆ GetNextEntry()

wxTarEntry * wxTarInputStream::GetNextEntry | ( |  | ) |

Closes the current entry if one is open, then reads the meta-data for the next entry and returns it in a wxTarEntry object, giving away ownership.

The stream is then open and can be read.

## ◆ OpenEntry()

bool wxTarInputStream::OpenEntry | ( | wxTarEntry & | entry | ) |

Closes the current entry if one is open, then opens the entry specified by the entry object.

entry should be from the same tar file, and the tar should be on a seekable stream.